"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.logger = exports.ApiManager = undefined;exports.



















loadConfigFile = loadConfigFile;exports.













































createConfigFile = createConfigFile;exports.default =













function () {var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultConfig();
    return new _ApiManager2.default(config);
};var _ApiManager = require("./ApiManager");var _ApiManager2 = _interopRequireDefault(_ApiManager);var _tmp = require("tmp");var _tmp2 = _interopRequireDefault(_tmp);var _fsExtra = require("fs-extra");var _path = require("path");var _os = require("os");var _logger = require("./logger");var _logger2 = _interopRequireDefault(_logger);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };} /**
                                                                                                                                                                                                                                                                                                                                                                                                                                             * API management tools module.
                                                                                                                                                                                                                                                                                                                                                                                                                                             * @module sapim
                                                                                                                                                                                                                                                                                                                                                                                                                                             */_tmp2.default.setGracefulCleanup(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    * Utility function for loading a configuration file.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    * @param {string} path The path to the config file.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    * @returns {Configuration} The resulting configuration or null if not found.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    */function loadConfigFile(path) {try {if ((0, _fsExtra.existsSync)(path)) {_logger2.default.debug("Loading configuration file: " + path);return JSON.parse((0, _fsExtra.readFileSync)(path, "utf8"));} else {_logger2.default.debug("No configuration file found at: " + path + ". Skipping.");return null;}} catch (e) {_logger2.default.warn("Unable to parse .sapim config file from: " + path + ". " + e.toString());return null;}}function getProperty(field, envVar, config) {if (process.env[envVar]) {_logger2.default.debug("Using " + field + " from the environment.");return process.env[envVar];} else {_logger2.default.debug("Using " + field + " from the configuration.");return config[field];}}var defaultConfigCache = null;function defaultConfig() {if (!defaultConfigCache) {var fileConfig = loadConfigFile((0, _path.resolve)(".sapim")) || loadConfigFile((0, _path.join)((0, _os.homedir)(), ".sapim")) || {};defaultConfigCache = { username: getProperty("username", "SAPIM_USERNAME", fileConfig), password: getProperty("password", "SAPIM_PASSWORD", fileConfig), host: getProperty("host", "SAPIM_HOST", fileConfig), proxy: getProperty("proxy", "HTTPS_PROXY", fileConfig) };}return defaultConfigCache;} /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  * Creates a .sapim configuration file.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  * @param {Configuration} content The content of the configuration file.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  * @param {boolean} [global=false] Flag indicating if the configuration should be global.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  * @param {boolean} [overwrite=false] Flag indicating if the existing configuration (if any) should
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  *  be overwritten.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  */function createConfigFile(content) {var global = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;var overwrite = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;var file = global ? (0, _path.join)((0, _os.homedir)(), ".sapim") : (0, _path.resolve)(".sapim");var opts = overwrite ? { flag: "w" } : { flag: "wx" };return (0, _fsExtra.writeFile)(file, JSON.stringify(content, null, 4), opts);} /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Factory function for the API tools class.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @function default
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @static
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @param {Configuration=} config The configuration used for creating the API tools.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *  If ommited, the configuration is loaded from the environment and / or the file system.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @returns {ApiManager} The API tools class instance.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */exports.ApiManager = _ApiManager2.default;exports.logger = _logger2.default;